// Uninstall.cpp

#include "windows.h"
#include <stdio.h>
#include <ctype.h>
#include <stdarg.h>

#include "ddeml.h"
#include "resource.h"

int Token(LPCSTR Line, LPCSTR *Tok);
BOOL DecrementRegKey(LPCSTR Path);
BOOL DeleteRegKey(LPCSTR DeleteKey);
void RemoveFolderIcon(LPCSTR FolderNameOrg);

//int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,LPSTR lpCmdLine,int nCmdShow);
BOOL InitInstance(HANDLE hInstance,int nCmdShow);
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
DWORD WINAPI ThreadEntry(LPVOID lpParameter);
BOOL CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
HANDLE hThread = NULL;
DWORD dwThreadID;
BOOL bIsVirgin = TRUE;
DWORD NumEvents = 0;
int main(int argc, char **argv);
void MyPrintf(LPCSTR fmt, ...);

HINSTANCE hInst;
HWND hWnd;
char PrgName[MAX_PATH];
extern BOOL DDEDeleteGroup(LPCSTR GroupName);
extern BOOL DDEIsFolderEmpty(LPCSTR FolderName);
extern BOOL DDEDeleteIcon(LPCSTR GroupName, LPCSTR IconName);

CONVCONTEXT   CCFilter = { sizeof (CONVCONTEXT), 0, 0, 0, 0L, 0L };
static DWORD lIdInst, lIdInst2;

HDDEDATA CALLBACK GroupDDECallback (UINT uiType, UINT uiFmt, HANDLE hConv,
      HSZ sz1, HSZ sz2, HDDEDATA hData, LONG lData1, LONG lData2) 
{
	return ((HDDEDATA) NULL);
}/* end GroupDDECallback */


enum // Tokens
{
	T_INC,
	T_FILE,
	T_KEY,
	T_DIR,
	T_PICON,
	T_CMD
};

typedef struct LinesHdr
{
	char *Buf;
	struct LinesHdr *Next;
} Lines;

Lines  *LinesRoot = NULL;
char *UninstFile = ".UnInst.inf";

int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	hInst = hInstance;
	MSG msg;
	DWORD State;
	BOOL DoContinue = TRUE;
	DWORD dwExitCode = 0;
	char *p = NULL;

	FILE *fp = fopen(UninstFile, "r");
	if (fp)
	{
		fgets(PrgName,sizeof(PrgName),fp);
		LPSTR p = PrgName;
		while(*p)
		{
			if (*p == '\n')
				*p = 0;
			++p;
		}
		fclose(fp);
	}

	if (!InitInstance(hInstance, nCmdShow))
		return (FALSE);
	
	while(DoContinue)
	{
		if (!NumEvents)
			goto get_mssages;
		
		State = MsgWaitForMultipleObjects(NumEvents,
			&hThread,
			0,
			60000,
			QS_ALLINPUT);

		if (State == (WAIT_OBJECT_0 + NumEvents))
		{
			while(PeekMessage(&msg,
				NULL,
				0,
				0,
				PM_NOREMOVE))
			{
get_mssages:
				if (!GetMessage(&msg, NULL, 0, 0))
				{
					DoContinue = FALSE;
					break;
				}

				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			continue;
		}
		else if (State == WAIT_OBJECT_0) 
		{
			if (!bIsVirgin)
			{
				// Uninstall Done
				NumEvents = 0;
				if (GetExitCodeThread(hThread, &dwExitCode))
				{
					
					SetWindowText(GetDlgItem(hWnd, IDC_LABEL), "Uninstall done.");		
					SetWindowText(GetDlgItem(hWnd, IDOK), "Close.");	
					EnableWindow(GetDlgItem(hWnd, IDOK), TRUE);
				}
			}
		}
	}

	return (msg.wParam);
}


BOOL InitApplication(HINSTANCE hInstance)
{
	return TRUE;
}

BOOL InitInstance(
    HANDLE          hInstance,
    int             nCmdShow 
)
{
	RECT ScreenRect, ClientRect;
	HWND hWndDesktop;
	if ((hWnd = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAINWINDLG),
		NULL, DialogProc)) == NULL)
	{
		int Err = GetLastError();
		return FALSE;
	}

	GetWindowRect(hWnd, &ClientRect);
	hWndDesktop = GetDesktopWindow();
	GetClientRect(hWndDesktop, &ScreenRect);
	ScreenRect.right /= 2;
	ScreenRect.right -= (ClientRect.right - ClientRect.left) / 2;
	ScreenRect.bottom -= ScreenRect.bottom / 2;
	ScreenRect.bottom -= (ClientRect.bottom - ClientRect.top) / 2;
	MoveWindow(hWnd, ScreenRect.right, ScreenRect.bottom, 
		(ClientRect.right - ClientRect.left),
		(ClientRect.bottom - ClientRect.top),
		TRUE);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}


BOOL CALLBACK DialogProc(HWND hwndDlg,
  UINT uMsg,
	WPARAM wParam,
  LPARAM lParam)
{
	switch(uMsg)
	{
			case WM_INITDIALOG:
				{
					char buf[2000];
					sprintf(buf, "This program will uninstall %s.\r\n\r\n Press OK to continue, Cancel to abort.", PrgName);
					SetDlgItemText(hwndDlg, IDC_LABEL, buf);
				}
				break;
			case WM_COMMAND:
			{
				switch(wParam)
				{
					case IDCANCEL:
						PostQuitMessage(-1);
						break;
					case IDOK:
						if (bIsVirgin)
						{
							hThread = CreateThread(NULL, 1024 * 8, ThreadEntry, NULL, 0, &dwThreadID);
							bIsVirgin = FALSE;
							EnableWindow(GetDlgItem(hwndDlg, IDOK), FALSE);
							ShowWindow(GetDlgItem(hwndDlg, IDCANCEL), SW_HIDE);
							NumEvents = 1;
						}
						else
						{
							PostQuitMessage(-1);
						}
						break;
					/*case IDC_BUTTON_README:
						ShellExecute(hWnd, "open", "readme.txt", NULL, "", SW_SHOW);
						break;
					case IDC_BUTTON_INSTALL:
						memset(&SI, 0, sizeof(SI));
						SI.cb = sizeof(SI);
						if (CreateProcess(".\\setup.exe", NULL, NULL,
							NULL, FALSE, 0, NULL, ".\\", &SI, &PI))
						{
							hInstallPrc = PI.hProcess;
							ShowWindow(hWnd, SW_HIDE);
						}
						break;*/
				}
			}
			break;
	}
	
	return FALSE;
}

DWORD WINAPI ThreadEntry(LPVOID lpParameter)
{
	char *argv[] = {"this", UninstFile};
	return main(2,(char **)argv);
}

int main(int argc, char **argv)
{
	FILE *fp;
	char buf[MAX_PATH*4], *p;
	LPCSTR Tok;
	Lines *ll;

	while(--argc)
	{
		p = *++argv;

		if (*p == '/')
			MyPrintf("Unknown argument %s\r\n", p);
		else
			UninstFile = p;
	}

	if ((fp = fopen(UninstFile,"r")) == NULL)
	{
		MyPrintf("Unable to open %s\r\nPress ENTER to exit.", UninstFile);
		getc(stdin);
		return -1;
	}

	*buf = 0;
	fgets(buf,sizeof(buf),fp);
	p = buf;
	while(*p)
	{
		if (*p == '\n')
			*p = 0;
		++p;
	}

	MyPrintf("%s will now be uninstalled\r\n", buf);

	// Build list in memory. We must process the .inf file in reverse order
	while(fgets(buf,sizeof(buf),fp) != NULL)
	{
		ll = new Lines;
		ll->Buf = strdup(buf);
		ll->Next = LinesRoot;
		LinesRoot = ll;
		if ((p = strchr(ll->Buf,'\n')) != NULL)
			*p = 0;
	}

	fclose(fp);

	for(ll = LinesRoot; ll; ll = ll->Next)
	{
		switch(Token(ll->Buf,&Tok))
		{
			case T_INC:
				// Decrement counter
				DecrementRegKey(Tok);
				break;

			case T_FILE:
				if ((*Tok == '0') && (Tok[2] == '0'))
				{
					// Not a shared file. 
					// Shared files are deleted by the decrement function...
					MyPrintf("Deleting file %s ", Tok + 4);
					if (DeleteFile(Tok + 4))
						MyPrintf(" .. Deleted.\r\n");
					else
						MyPrintf(" .. Failed to delete file.\r\n");
				}

			case T_KEY:
				DeleteRegKey(Tok);
				break;

			case T_DIR:
				RemoveDirectory(Tok);
				break;

			case T_PICON:
				RemoveFolderIcon(Tok);
				break;

			case T_CMD:
				{
					MyPrintf("Execuing '%s'... ", Tok);
					STARTUPINFO SI;
					memset(&SI, 0, sizeof(SI));
					SI.cb = sizeof(SI);

					PROCESS_INFORMATION PI;
					memset(&PI, 0, sizeof(PI));

					if (CreateProcess(NULL, 
						(LPTSTR)Tok, 
						NULL, 
						NULL, 
						FALSE, 
						0, 
						NULL, 
						NULL, 
						&SI, 
						&PI))
					{
						MyPrintf("OK. Waiting...");
						WaitForSingleObject(PI.hThread, INFINITE);
					}
					else	
					{
						int Err = GetLastError();
						MyPrintf("Failed! (%d)", Err);
					}

					MyPrintf("\r\n");
				}
		}
	}

	DeleteFile(UninstFile);
	MyPrintf("Done. Press [Close] to exit.");
	return 0;
}


int Token(LPCSTR Line, LPCSTR *Tok)
{
	switch(*Line)
	{
		case 'i': // Inc
			*Tok = Line + 4;
			return T_INC;
		case 'f': // File
			*Tok = Line + 5;
			return T_FILE;
		case 'k': // Registery key
			*Tok = Line + 4;
			return T_KEY;
		case 'd': // Directory
			*Tok = Line + 4;
			return T_DIR;
		case 'p': // Program manager folder icon (Nt 3.51)
			*Tok = Line + 6;
			return T_PICON;
		case 'c':
			*Tok = Line + 4;
			return T_CMD;
	}
	return -1;
}

BOOL DecrementRegKey(LPCSTR Path)
{
	DWORD dwNihl, dwSize = sizeof(DWORD);
	LONG Rval;
	HKEY hkey;
	DWORD dwCounter = 0;
	
	if (RegOpenKeyEx(
		HKEY_LOCAL_MACHINE,
		"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDLLs\\",
		0,
		KEY_QUERY_VALUE | KEY_WRITE,
		&hkey) == ERROR_SUCCESS) 
	{
		if ((Rval = RegQueryValueEx(
			hkey,
			Path,
			NULL,
			&dwNihl,
			(LPBYTE)&dwCounter,
			&dwSize)) == ERROR_SUCCESS)
		{
			if (dwCounter > 0)
			{
					--dwCounter;	

				if (dwCounter == 0)
				{
					if (DeleteFile(Path))
					{
						char *MyBuf = new char[MAX_PATH * 3];
						sprintf(
							"HKEY_LOCAL_MACHINE SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDLLs\\%s",
							Path);
						RegCloseKey(hkey);
						DeleteRegKey(MyBuf);
						delete MyBuf;
						return TRUE;
					}
				}
				
				RegSetValueEx(
					hkey,
					Path,
					0,
					REG_DWORD,
					(LPBYTE)&dwCounter,
					dwSize);
				
			}
		}

		RegCloseKey(hkey);
		return TRUE;
	}
	return FALSE;
}


BOOL DeleteRegKey(LPCSTR DeleteKey)
{
	HKEY hkey, MainKey;
	char szKey[MAX_PATH];
	LPSTR Tag;
	char *MyBuf = strdup(DeleteKey);
	char *p = strtok(MyBuf," \n");

	if (!strcmp(p,"HKEY_CURRENT_USER"))
		MainKey = HKEY_CURRENT_USER;
	else if (!strcmp(p,"HKEY_CLASSES_ROOT"))
		MainKey = HKEY_CLASSES_ROOT;
	else if (!strcmp(p,"HKEY_LOCAL_MACHINE"))
		MainKey = HKEY_LOCAL_MACHINE;
	else if (!strcmp(p,"HKEY_USERS"))
		MainKey = HKEY_USERS;
	else
		return FALSE;

	p = strtok(NULL,"\n");

	strcpy(szKey, p);

	delete MyBuf;

	Tag = strrchr(szKey,'\\');
	*++Tag = 0;

	Tag = strrchr(DeleteKey,'\\');
	++Tag;

	if (RegOpenKeyEx(
		MainKey,
		szKey,
		0,
		KEY_WRITE,
		&hkey) == ERROR_SUCCESS) 
	{
		RegDeleteKey(hkey,Tag);
		RegCloseKey(hkey);
	}

	return FALSE;
}


void RemoveFolderIcon(LPCSTR FolderNameOrg)
{
	LPSTR FolderName = strdup(FolderNameOrg);

	char *IconName = strchr(FolderName,'@');

	if (!IconName || !*IconName)
		return;

	*IconName++ = 0;

	DDEDeleteIcon(FolderName, IconName);

	if (DDEIsFolderEmpty(FolderName))
		DDEDeleteGroup(FolderName);

	delete FolderName;
}

BOOL DDEIsFolderEmpty(LPCSTR FolderName)
{
	LPBYTE     lpByte;
	LPSTR      szGroups;
	LPSTR      szToken;
	LPSTR      szMem;
	DWORD       lResult;
	DWORD       lIdLocal;
	HCONV      hConv;
	HDDEDATA   hDdeData;
	HSZ        szProgMan;
	HSZ        szTopic;
	BOOL		   Rval = FALSE;


	// Initialize the Dde id to 0

	lIdLocal = 0L;
	szGroups = NULL;

	// Attempt to initialize a conversation.

	if (DdeInitialize (&lIdLocal, (PFNCALLBACK) GroupDDECallback,
		(DWORD) APPCMD_CLIENTONLY, 0L)) 
	{ 
		return (FALSE);
	}/*endIf*/

	// Start a critical section. This fixes a problem where the DDEML
	// Can hang under threaded conditions.


	// Create a string handle for the Dde conversation.

	szProgMan = DdeCreateStringHandle (lIdLocal, "PROGMAN", CP_WINANSI);
	
	// Connect to the program manager.

	hConv = DdeConnect (lIdLocal, szProgMan, szProgMan, &CCFilter);

	// Create a handle for the Group topic.

	szTopic = DdeCreateStringHandle (lIdLocal, FolderName, CP_WINANSI);

	// Execute a request for the group names.

	hDdeData = DdeClientTransaction (NULL, 0L, hConv, szTopic, CF_TEXT,
		XTYP_REQUEST, 1000, &lResult);

	DdeFreeStringHandle (lIdLocal, szProgMan);
	DdeFreeStringHandle (lIdLocal, szTopic);

	// Disconnect the conversation.

	DdeDisconnect (hConv);

	// Verify that we got something back.

	if (hDdeData && (hDdeData != (HDDEDATA) TRUE)) 
	{

		// Access the data to get a character pointer.

		lpByte = DdeAccessData (hDdeData, &lResult);

		// allocate a block of memory to use.

		szGroups = szMem = (LPSTR)VirtualAlloc (NULL, lResult, MEM_COMMIT,
			PAGE_READWRITE);
		if (!szMem) 
		{
			lResult = GetLastError ();
		} 
		else 
		{

			// Copy the Dde data to our own block.

			memcpy (szGroups, lpByte, lResult);
		}/*endIf*/

		// Free the Dde data that is there. This is our responsibility.

		DdeUnaccessData (hDdeData);
		DdeFreeDataHandle (hDdeData);
	}/*endIf*/

	// If we have a memory block then parse it.

	if (szMem != NULL) 
	{

		// Search for 'cr'.

		// While we have a token use it.
		if ((szToken = strtok (szGroups, ",")) != NULL)
			if ((szToken = strtok (NULL, ",")) != NULL)
				if ((szToken = strtok (NULL, ",")) != NULL)
					Rval = atoi(szToken) == 0;

		// Release the memory block.

		VirtualFree (szMem, lResult, MEM_DECOMMIT);
	}/*endIf*/

	// Release the DDEML.

	DdeUninitialize (lIdLocal);

	return Rval;
}


BOOL DDEDeleteGroup(LPCSTR GroupName)
{
	HDDEDATA   hData;
	//LPSTR      szText;
	LPSTR      szCommand;
	HCONV      hConv;
	HSZ        szProgMan;
	DWORD       lResult;

	// Allocate a block of memory for the group name that the user has selected.
	//szText = VirtualAlloc (NULL, 64, MEM_COMMIT, PAGE_READWRITE);

	// Allocate a block of memory for the command to send to the Program Manager.
	szCommand = (LPSTR) VirtualAlloc (NULL, 128, MEM_COMMIT, PAGE_READWRITE);
	if (szCommand) 
	{
		// We got the memory so we can proceed.

		// Initialize the DDE conversation here.

		if (DdeInitialize (&lIdInst, (PFNCALLBACK) GroupDDECallback,
			(DWORD) APPCMD_CLIENTONLY, 0L)) 
		{
			MyPrintf("***DDEML Initialization Failure\r\n");
			//VirtualFree (szText, 128, MEM_DECOMMIT);
			VirtualFree (szCommand, 128, MEM_DECOMMIT);
			return FALSE;
		}/*endIf*/

		// Create a DDEML string handle for the Program Manager.
		szProgMan = DdeCreateStringHandle (lIdInst, "PROGMAN", CP_WINANSI);
		if (szProgMan) 
		{

			// String handle created so continue.

			// Establish a conversation with the Program Manager.
			hConv = DdeConnect (lIdInst, szProgMan, szProgMan, &CCFilter);

			// Create the group by creating the command line.
			// The program manager will activate an existing group if the name matches
			// a DDE attempt to create a new group so the create versus show is somewhat
			// redundant.
			sprintf (szCommand, "[DeleteGroup(%s)]", GroupName);

			// Create a DDEML data handle for the command.
			hData = DdeCreateDataHandle (lIdInst, (LPBYTE)szCommand,
				strlen (szCommand) + 1, 0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the transaction to the server waiting a maximum of 10 seconds.
			// The server will release the data handle.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF, hConv,
				(HSZ) NULL, 0, XTYP_EXECUTE, 10000, &lResult)) 
			{

				// If it fails get the error code.
				lResult = DdeGetLastError (lIdInst);
				MyPrintf("***DdeClientTransaction Failed");
			}/*endIf*/

						// Group already exists so activate it.
			sprintf (szCommand, "[ShowGroup(%s,1)]", GroupName);

			// Create a DDEML data handle for the command.
			hData = DdeCreateDataHandle (lIdInst, (LPBYTE)szCommand, strlen (szCommand),
				0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the transaction to the server waiting a maximum of 10 seconds.
			// The server will release the data handle.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF, hConv,
				(HSZ) NULL, 0, XTYP_EXECUTE, 10000, &lResult)) 
			{

				// If it fails get the error code.
				lResult = DdeGetLastError (lIdInst);
			}/*endIf*/
		
			// Release the Program Manager string handle.
			DdeFreeStringHandle (lIdInst, szProgMan);

			// Disconnect from the server.
			DdeDisconnect (hConv);
		} 
		else 
		{
			lResult = DdeGetLastError (lIdInst);
		}/*endIf*/

		// Free the two blocks of memory that were allocated.
		//VirtualFree (szText, 64, MEM_DECOMMIT);
		VirtualFree (szCommand, 64, MEM_DECOMMIT);

		// Uninitialize the conversation here so that resources are freed.

		DdeUninitialize (lIdInst);
		lIdInst = 0L;
		return (TRUE);
	} 
	else 
	{
		MyPrintf("****Memory Allocation failure");
	}
	
	return (FALSE);
}


BOOL DDEDeleteIcon(LPCSTR GroupName, LPCSTR IconName)
{
	HDDEDATA   hData;
	//LPSTR      szText;
	LPSTR      szCommand;
	HCONV      hConv = (HCONV)0;
	HSZ        szProgMan;
	DWORD       lResult;

	// Allocate a block of memory for the group name that the user has selected.
	//szText = VirtualAlloc (NULL, 64, MEM_COMMIT, PAGE_READWRITE);

	// Allocate a block of memory for the command to send to the Program Manager.
	szCommand = (LPSTR) VirtualAlloc (NULL, 128, MEM_COMMIT, PAGE_READWRITE);
	if (szCommand) 
	{
		// We got the memory so we can proceed.

		// Initialize the DDE conversation here.

		if (DdeInitialize (&lIdInst, (PFNCALLBACK) GroupDDECallback,
			(DWORD) APPCMD_CLIENTONLY, 0L)) 
		{
			MyPrintf("****DDEML Initialization Failure");
			//VirtualFree (szText, 128, MEM_DECOMMIT);
			VirtualFree (szCommand, 128, MEM_DECOMMIT);
			return FALSE;
		}/*endIf*/

		// Create a DDEML string handle for the Program Manager.
		szProgMan = DdeCreateStringHandle (lIdInst, "PROGMAN", CP_WINANSI);
		if (szProgMan) 
		{

			sprintf (szCommand, "[ShowGroup(%s,1)]", GroupName);

			// Create a DDEML data handle for the command.
			hData = DdeCreateDataHandle (lIdInst, (LPBYTE)szCommand, strlen (szCommand),
				0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the transaction to the server waiting a maximum of 10 seconds.
			// The server will release the data handle.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF, hConv,
				(HSZ) NULL, 0, XTYP_EXECUTE, 10000, &lResult)) 
			{

				// If it fails get the error code.
				lResult = DdeGetLastError (lIdInst);
			}/*endIf*/

			// Establish a conversation with the Program Manager.
			hConv = DdeConnect (lIdInst, szProgMan, szProgMan, &CCFilter);

			// Create the group by creating the command line.
			// The program manager will activate an existing group if the name matches
			// a DDE attempt to create a new group so the create versus show is somewhat
			// redundant.
			sprintf (szCommand, "[DeleteItem(%s)]", IconName);

			// Create a DDEML data handle for the command.
			hData = DdeCreateDataHandle (lIdInst, (LPBYTE)szCommand,
				strlen (szCommand) + 1, 0, (HSZ) NULL, CF_TEXT, 0L);

			// Send the transaction to the server waiting a maximum of 10 seconds.
			// The server will release the data handle.
			if (!DdeClientTransaction ((LPBYTE) hData, 0xFFFFFFFF, hConv,
				(HSZ) NULL, 0, XTYP_EXECUTE, 10000, &lResult)) 
			{

				// If it fails get the error code.
				lResult = DdeGetLastError (lIdInst);
				MyPrintf("****DdeClientTransaction Failed");
			}/*endIf*/
		
			// Release the Program Manager string handle.
			DdeFreeStringHandle (lIdInst, szProgMan);

			// Disconnect from the server.
			DdeDisconnect (hConv);
		} 
		else 
		{
			lResult = DdeGetLastError (lIdInst);
		}/*endIf*/

		// Free the two blocks of memory that were allocated.
		//VirtualFree (szText, 64, MEM_DECOMMIT);
		VirtualFree (szCommand, 64, MEM_DECOMMIT);

		// Uninitialize the conversation here so that resources are freed.

		DdeUninitialize (lIdInst);
		lIdInst = 0L;
		return (TRUE);
	} 
	else 
	{
		MyPrintf("****Memory Allocation failure");
	}
	
	return (FALSE);
}

void MyPrintf(LPCSTR fmt, ...)
{
	va_list ap;
	char buf[1024 * 2];

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
	va_end(ap);

	HWND wLog = GetDlgItem(hWnd, IDC_LOG);

	SendMessage(wLog, EM_SETSEL, -1, -1);
	SendMessage(wLog, EM_REPLACESEL, FALSE, (LPARAM)buf);
}
