
#ifndef __SETUP_H
#define __SETUP_H


enum OsTypeDef
{
	OS_UNKNOWN,
	OS_WIN95,
	OS_NT351,
	OS_NT4
};

class WARSETUP_DLL CFileList
{
public:
	CFileList();

	char m_SrcName[MAX_PATH];
	char m_DstName[MAX_PATH];
	int m_MenuMode;
	char m_MenuName[MAX_PATH];
	char m_UninstCmd[MAX_PATH];
	BOOL	m_bPrimaryTarget;
	CFileList *m_Next;
};


class WARSETUP_DLL CClassList
{
public:
	char m_Name[MAX_PATH];
	char m_InstallDir[MAX_PATH];
	CFileList *m_FileList;
	BOOL m_DoNT351;
	BOOL m_DoNT4;
	BOOL m_DoWin95;
	BOOL m_IsShared;
	BOOL m_IsSystem;
	BOOL m_IsTypical;
	BOOL m_IsMinimum;
	BOOL m_Include; // used by setup to determine if these files shall be installed
	CClassList *m_Next;
};



class WARSETUP_DLL Setup
{
public:
	Setup();
	~Setup();
	BOOL Create();
	void MyMessageBox(LPCSTR Text);

	BOOL InstallSelection(HWND hWndProgress, HWND hWndClass, int Mode, int Mask);
	static int MySscanf(LPCSTR buf, LPCSTR Format, ...);
	LPCSTR StripPath(LPCSTR Path);
	HRESULT CreateLink(LPCSTR lpszPathObj, LPCSTR lpszPathLink, LPCSTR lpszDesc);
	BOOL IncRegCnt(LPCSTR Path);
	BOOL GetFilePermissions(LPCSTR Path, DWORD& Perms);
	BOOL CreatePathForDirectory(LPCSTR Path);

	BOOL DDECreateGroup (LPCSTR GroupName);
	BOOL DDEAddProgramItem(LPCSTR szProgName, LPCSTR szExePath);
	BOOL DDEGroupRetrieval (HWND hListBox);
	BOOL DDEIsFolderEmpty(LPCSTR FolderName);

	BOOL LoadNT4Info();
	BOOL LoadNt351Info();
	BOOL LoadWin95Info();
	BOOL GetRegisteryString(HKEY MainKey, LPCSTR Path, LPSTR Buf, size_t Buflen);
	BOOL SetRegisteryString(HKEY MainKey, LPCSTR Key, LPCSTR Buf, size_t Buflen);
	BOOL CreateRegisteryKey(HKEY MainKey, LPCSTR Key);
	BOOL LoadInfFile();
	void ExpandMacros(LPSTR Path);
	BOOL InstallFile(CClassList *cl, CFileList *fl);
	BOOL Get(LPSTR Buf,int Bytes, FILE *fp);
	DWORD MyVerInstallFile(DWORD uFlags,LPTSTR szSrcFileName,	LPTSTR szDestFileName,LPTSTR szSrcDir,LPTSTR szDestDir,	LPTSTR szCurDir, LPTSTR szTmpFile,PUINT lpuTmpFileLen);
	void LoadPrimaryTarget(LPCSTR Path);
	BOOL MyGetVerInfo(LPVOID Vbuf, LPSTR *Val, LPCSTR Name);
	BOOL QueryFileInfoForListCntr(LPCSTR Name, HWND hWnd, int Row, int Col, ...);

	char WinDir[MAX_PATH];
	char SystemDir[MAX_PATH];
	char ProgramFolderDir[MAX_PATH];
	char StartUpMenu[MAX_PATH];
	char UserProgramFolderDir[MAX_PATH];
	char ProgramDir[MAX_PATH];
	char DestPath[MAX_PATH];
	char FolderName[MAX_PATH];
	char m_PrimaryTarget[MAX_PATH];
	OSVERSIONINFO OsInfo;
	OsTypeDef OsType;

	FILE *m_LogFp;
	FILE *m_UnInstFp;

	CClassList *m_FileClassRoot;
	char m_Menu[MAX_PATH]; // Start menu name
	char m_Name[MAX_PATH];
	char m_VerboseName[MAX_PATH];
	char m_Copyright[512];
	char m_InstallDir[MAX_PATH];
	char m_CompanyName[MAX_PATH];
	char m_Comments[1024];
	char m_SpecialBuild[512];
	char m_LegalTrademarks[1024];
	char m_Version[128];
	BOOL m_DoReboot; // System must be rebooted before installation is complete

	// Valid platforms
	BOOL m_NT351;
	BOOL m_NT4;
	BOOL m_Win95;
};

#endif // __SETUP_H
