
#ifndef WARSETUP_DLL
#define WARSETUP_DLL __declspec(dllimport)
#endif

#ifndef EXT
#define EXT extern
#endif

#include "assert.h"
#define ASSERT assert

void WARSETUP_DLL UpdateProgress(HWND hWnd, const char *FileName, int Progress);
void WARSETUP_DLL PumpMessages();
EXT HINSTANCE WARSETUP_DLL hPlugin;
EXT HINSTANCE WARSETUP_DLL hInst;
EXT HWND WARSETUP_DLL hWnd;


#include "..\WarSetup\SetupFiles.h"
#include "..\WarSetup\Dialogs.h"

#define WARPFUNC BOOL (WINAPI *)(HWND, Setup *, PropertyPageList *)
// Export function for WarInstall initialization
// Called after the default pages are set up, but before the screen is updated
// Return FALSE to abort the setup program
EXT BOOL WARSETUP_DLL (WINAPI * __InitPlugin)(
	HWND hWnd, // WarSetup main window
	Setup *pSetup, // Setup processor
	PropertyPageList *pPropertySheet); // The property sheet, including default pages, except for the finish page

	// Export function for WarInstall initialization
// Called after all property pares are set up, but before the screen is updated
// Return FALSE to abort the setup program
EXT BOOL WARSETUP_DLL (WINAPI * __PreperePlugin)(
	HWND hWnd, // WarSetup main window
	Setup *pSetup, // Setup processor
	PropertyPageList *pPropertySheet); // The property sheet, including default pages, except for the finish page

// Export function for WarInstall initialization
// Called just after the first property-page is displayed
// Return FALSE to abort the setup program
EXT BOOL WARSETUP_DLL (WINAPI * __PreProcessPlugin)(
	HWND hWnd, // WarSetup main window
	Setup *pSetup, // Setup processor
	PropertyPageList *pPropertySheet); // The property sheet, including default pages, except for the finish page

// Export function for WarInstall initialization
// Called before the setup thread exits
// The return value is ignored
EXT BOOL WARSETUP_DLL (WINAPI * __PostProcessPlugin)(
	HWND hWnd, // WarSetup main window
	Setup *pSetup, // Setup processor
	PropertyPageList *pPropertySheet); // The property sheet, including default pages, except for the finish page

// Export function for WarInstall initialization
// Called if the user press the Cancel button
// Return FALSE to deny the cancel operation
EXT BOOL WARSETUP_DLL (WINAPI * __OnCancelPlugin)(
	HWND hWnd, // WarSetup main window
	Setup *pSetup, // Setup processor
	PropertyPageList *pPropertySheet); // The property sheet, including default pages, except for the finish page

