
class WelcomeWard170Page : public PropertyPage
{
public:
	WelcomeWard170Page(Setup *pSetup);
	virtual BOOL OnActivate();
};

class SetupModeWard170Page : public PropertyPage
{
public:
	SetupModeWard170Page(Setup *pSetup);
	virtual BOOL OnActivate();
	virtual BOOL OnNext();
	virtual BOOL OnProcess();
	virtual void OnUpdate(BOOL bSave = TRUE);

	enum SetupModesDef
	{
		mode_new,
		mode_upgr_pre170,
		mode_upgr_170,
		mode_invalid
	} m_Mode;

	BOOL m_bDoServerInstall;
	BOOL m_bDoClientInstall;
};

class RootFileWard170Page : public PropertyPage
{
public:
	RootFileWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);
	virtual BOOL OnActivate();
	virtual BOOL OnMessage(UINT uMsg,WPARAM wParam,LPARAM lParam);
	void OnBrowse();

	char m_Path[MAX_PATH];
};

class UpgradePathWard170Page : public PropertyPage
{
public:
	UpgradePathWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);
	virtual BOOL OnActivate();
	virtual BOOL OnMessage(UINT uMsg,WPARAM wParam,LPARAM lParam);
	void OnBrowse();

	char m_Path[MAX_PATH];
	LPCSTR m_DatName;
};

class SystemNameWard170Page : public PropertyPage
{
public:
	SystemNameWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);
	virtual BOOL OnActivate();

	char m_SystemName[128];
};

class SecurityWard170Page : public PropertyPage
{
public:
	SecurityWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);

	BOOL m_bAllowAnon;
	BOOL m_bListUpload;
	BOOL m_bReadUpload;
};

class PasswordWard170Page : public PropertyPage
{
public:
	PasswordWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);

	char m_Passwd[32];
};

class EmailWard170Page : public PropertyPage
{
public:
	EmailWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);

	char m_Email[32];
};

class NameTagWard170Page : public PropertyPage
{
public:
	NameTagWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);

	char m_Tag[16];
};

class ServiceWard170Page : public PropertyPage
{
public:
	ServiceWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave = TRUE);

	BOOL m_bService;
};

class ReadyToGoWard170Page : public PropertyPage
{
public:
	ReadyToGoWard170Page(Setup *pSetup);
};

class ProcessWard170Page : public PropertyPage
{
public:
	ProcessWard170Page(Setup *pSetup);
	virtual BOOL OnActivate();
	virtual BOOL OnProcess();
};

class FTPPortWard170Page : public PropertyPage
{
public:
	FTPPortWard170Page(Setup *pSetup);
	virtual void OnUpdate(BOOL bSave);

	int m_Port;
};

