

#include <windows.h>
#include "resource.h"

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,LPSTR lpCmdLine,int nCmdShow);
BOOL InitApplication(HANDLE hInstance);
BOOL InitInstance(HANDLE hInstance,int nCmdShow);
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
int main(int, char**);
DWORD WINAPI ThreadEntry(LPVOID lpParameter);
BOOL CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
void UpdateDisplay(const char *FileName, long Size, int FileNo, int TotalFiles);
void CleanUpMess(void);
void AddNewFile(LPCSTR FileName);

struct ProgressInfo
{
	LPCSTR m_Name[MAX_PATH];
	DWORD m_Size;
	int m_Cnt;
	int m_Total;
} CurrentProgressInfo;

struct NameListDef
{
	LPSTR m_FileName;
	struct NameListDef *m_pNext;
} *pRootNode = NULL;

enum MessagesDef
{
	MYWM_PROGRESS = WM_USER +10,
	X_INVALID,
};

HANDLE hInst;
HWND hWnd;
HANDLE hInstallPrc;

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	HANDLE hThread;
	DWORD dwThreadID;
	DWORD State;
	BOOL DoContinue = TRUE;
	DWORD NumEvents = 1;
	DWORD dwExitCode = 0;
	char *p = NULL;
	struct ProgressInfo PI;

	hInst = hInstance;

	if (!hPrevInstance)
		if (!InitApplication(hInstance))
			return (FALSE);
			 
	if (!InitInstance(hInstance, nCmdShow))
		return (FALSE);

	// Find temp dir
	p = getenv("TEMP");
	if (p == NULL)
		p = getenv("TMP");
	if (p == NULL)
	{
		p = "C:\\TEMP";
		if (!CreateDirectory(p, NULL))
		{
			MessageBox(NULL, "Unable to find or create a temp dir.", "Error", MB_OK);
			return -1;
		}
	}

	if (!SetCurrentDirectory(p))
	{
		MessageBox(NULL, "Unable to set current directory to temp dir.", p, MB_OK);
		return -1;
	}

	hThread = CreateThread(NULL, 1024 * 8, ThreadEntry, NULL, 0, &dwThreadID);
	
	while(DoContinue)
	{
		if (hInstallPrc)
			NumEvents = 1;

		if (!NumEvents)
			goto get_mssages;
		
		State = MsgWaitForMultipleObjects(NumEvents,
			hInstallPrc ? &hInstallPrc : &hThread,
			0,
			60000,
			QS_ALLINPUT);

		if (State == (WAIT_OBJECT_0 + NumEvents))
		{
			while(PeekMessage(&msg,
				NULL,
				0,
				0,
				PM_NOREMOVE))
			{
get_mssages:
				if (!GetMessage(&msg, NULL, 0, 0))
				{
					DoContinue = FALSE;
					break;
				}

				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			continue;
		}
		else if (State == WAIT_OBJECT_0) 
		{
			if (hInstallPrc)
			{
				// Installation done.
				NumEvents = 0;
				CleanUpMess();
				hInstallPrc = NULL;
				PostQuitMessage(0);
			}
			else
			{
				// Uncompression Done
				NumEvents = 0;
				if (GetExitCodeThread(hThread, &dwExitCode))
				{
					PI.m_Name[0] = 0;
					PI.m_Size = 0;
					PI.m_Cnt = 2;
					PI.m_Total = 1;
					SendMessage(hWnd, MYWM_PROGRESS, (WPARAM)&PI, (LPARAM)NULL);

					if (dwExitCode != 0)
					{
						SetWindowText(GetDlgItem(hWnd, IDC_INFO), "War Zipper failed to extracted the files.");		
						EnableWindow(GetDlgItem(hWnd, IDC_BUTTON_QUIT), TRUE);
						continue;
					}
				}

				if (GetFileAttributes("setup.exe") != 0xffffffff)
					EnableWindow(GetDlgItem(hWnd, IDC_BUTTON_INSTALL), TRUE);

				if (GetFileAttributes("readme.txt") != 0xffffffff)
					EnableWindow(GetDlgItem(hWnd, IDC_BUTTON_README), TRUE);

				EnableWindow(GetDlgItem(hWnd, IDC_BUTTON_QUIT), TRUE);
				SetWindowText(GetDlgItem(hWnd, IDC_INFO), "War Zipper has extracted the files\r\nYou can now start the install procedure.");
			}
		}
	}

	return (msg.wParam);
}

BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASSEX  wc;
		memset(&wc,0,sizeof(wc));

		wc.cbSize = sizeof(wc);
    wc.style = CS_CLASSDC;
    wc.lpfnWndProc = WndProc;
    wc.hInstance = hInstance;
		wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_SETUP));
    wc.hbrBackground = GetStockObject(LTGRAY_BRUSH);
    wc.lpszClassName = "WarProgressClass";

    if (!RegisterClassEx (&wc))
			return FALSE;

		return TRUE;
}


BOOL InitInstance(
    HANDLE          hInstance,
    int             nCmdShow 
)
{
	RECT ScreenRect, ClientRect;
	HWND hWndDesktop;
	if ((hWnd = CreateDialog(hInst, MAKEINTRESOURCE(IDD_MAINWINDLG),
		NULL, DialogProc)) == NULL)
	{
		int Err = GetLastError();
		return FALSE;
	}

	/*if ((hWnd = CreateWindow(
		"WarUnzipperClass",
		"War Unzpper",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,200,100,
		NULL,
		NULL,
		hInst,
		NULL)) == NULL)
		return FALSE;*/

	GetWindowRect(hWnd, &ClientRect);
	hWndDesktop = GetDesktopWindow();
	GetClientRect(hWndDesktop, &ScreenRect);
	ScreenRect.right /= 2;
	ScreenRect.right -= (ClientRect.right - ClientRect.left) / 2;
	ScreenRect.bottom -= ScreenRect.bottom / 2;
	ScreenRect.bottom -= (ClientRect.bottom - ClientRect.top) / 2;
	MoveWindow(hWnd, ScreenRect.right, ScreenRect.bottom, 
		(ClientRect.right - ClientRect.left),
		(ClientRect.bottom - ClientRect.top),
		TRUE);

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);

	return TRUE;
}


BOOL CALLBACK DialogProc(HWND hwndDlg,
  UINT uMsg,
	WPARAM wParam,
  LPARAM lParam)
{
	STARTUPINFO SI;
	PROCESS_INFORMATION PI;

	switch(uMsg)
	{
		case WM_COMMAND:
			{
				switch(wParam)
				{
					case IDC_BUTTON_QUIT:
						PostQuitMessage(-1);
						break;
					case IDC_BUTTON_README:
						ShellExecute(hWnd, "open", "readme.txt", NULL, "", SW_SHOW);
						break;
					case IDC_BUTTON_INSTALL:
						memset(&SI, 0, sizeof(SI));
						SI.cb = sizeof(SI);
						if (CreateProcess(".\\setup.exe", NULL, NULL,
							NULL, FALSE, 0, NULL, ".\\", &SI, &PI))
						{
							hInstallPrc = PI.hProcess;
							ShowWindow(hWnd, SW_HIDE);
						}
						break;
				}
			}
			break;

		case MYWM_PROGRESS:
			memcpy(&CurrentProgressInfo,(struct ProgressInfo *)wParam, 
				sizeof(struct ProgressInfo));
			
			if (CurrentProgressInfo.m_Name[0])
				AddNewFile((LPCSTR)CurrentProgressInfo.m_Name);

			InvalidateRect(GetDlgItem(hWnd, IDC_PROGRESS), NULL, TRUE);
			UpdateWindow(GetDlgItem(hWnd, IDC_PROGRESS));
			break;
	}
	
	return FALSE;
}



DWORD WINAPI ThreadEntry(LPVOID lpParameter)
{
	char *argv[] = {"this", "-o"};
	return main(2,(char **)argv);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	static UINT s_uTaskbarRestart;
	HDC hDC;
	PAINTSTRUCT ps;
	HBRUSH hBgBrush, hFgBrush;
	RECT ClientRect, TextRect;
	int Percent = 0;
	LPCSTR UseText = "--- all files extracted ---";
	
	if (CurrentProgressInfo.m_Total && CurrentProgressInfo.m_Cnt)
	{
		if (CurrentProgressInfo.m_Total < CurrentProgressInfo.m_Cnt)
			Percent = 100;
		else
			Percent = (int)(((float)CurrentProgressInfo.m_Cnt 
				/ (float)CurrentProgressInfo.m_Total) * (float)100);
	}
	
	switch(uMessage)
	{
		case WM_PAINT:
			//hDC = GetDC(hWnd);
			BeginPaint(hWnd, &ps);
			hDC = ps.hdc;
			GetClientRect(hWnd, &ClientRect);
			TextRect = ClientRect;
			hBgBrush = GetStockObject(GRAY_BRUSH);
			if (Percent == 100)
				hFgBrush = CreateSolidBrush(RGB(0,255,0));
			else
			{
				hFgBrush = GetStockObject(WHITE_BRUSH);
				UseText = (LPCSTR)CurrentProgressInfo.m_Name;
			}
			FillRect(hDC, &ClientRect, hBgBrush);
			ClientRect.right -= (int)((float)ClientRect.right - (((float)ClientRect.right / 100) * (float)Percent));
			FillRect(hDC, &ClientRect, hFgBrush);
			SetTextColor(hDC, RGB(0,0,0));
			SetBkMode(hDC, TRANSPARENT);
			
			DrawText(hDC, 
				(LPCTSTR)UseText,
				strlen(UseText),
				&TextRect,
				DT_CENTER | DT_VCENTER);
			
			if (Percent == 100)
				DeleteObject(hFgBrush);
			break;
	}
	
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

void UpdateDisplay(const char *FileName, long Size, int FileNo, int TotalFiles)
{
	struct ProgressInfo PI;

	strcpy((LPSTR)PI.m_Name, (LPCSTR)FileName);
	PI.m_Size = Size;
	PI.m_Cnt = FileNo;
	PI.m_Total = TotalFiles;

	SendMessage(hWnd, MYWM_PROGRESS, (WPARAM)&PI, (LPARAM)NULL);

/*
#ifdef _DEBUG
	Sleep(1000);
#endif
*/
}


void CleanUpMess(void)
{
	struct NameListDef *p, *pNext;
	for(p = pRootNode; p; p = pNext)
	{
		pNext = p->m_pNext;
		DeleteFile(p->m_FileName);
		free(p->m_FileName);
		free(p);
	}
}

void AddNewFile(LPCSTR FileName)
{
	struct NameListDef *p = (struct NameListDef *)malloc(sizeof(struct NameListDef));
	p->m_FileName = strdup(FileName);
	p->m_pNext = pRootNode;
	pRootNode = p;
}

